import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.Resource.Factory;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.mde.web.model.TemplateModelToJava;

import com.enemy.Enemy.Behaviour;
import com.enemy.Enemy.impl.EnemyPackageImpl;


public class ConvertToJava {

	public static void main(String[] args) {
		EnemyPackageImpl.init();
		
		Factory.Registry.INSTANCE.getExtensionToFactoryMap().put("enemy",new XMIResourceFactoryImpl());
		
		ResourceSet resourceSet = new ResourceSetImpl();
		
		Resource resource = resourceSet.getResource(URI.createURI("model/behaviour.enemy"),true);
		Behaviour behaviour = (Behaviour)resource.getContents().get(0);
		
		TemplateModelToJava java = new TemplateModelToJava();
		
		try {
			FileWriter output = new FileWriter("src-gen/Test.java");
			
			BufferedWriter writer = new BufferedWriter(output);
			
			writer.write(java.generate(behaviour));
						
			writer.close();
		} catch (IOException e) {			
			e.printStackTrace();
		}		
	}
}
